/*-
 * Copyright (C) @BABOLO  2007 Nov 09
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pgob.h,v 1.3 2007/11/10 22:00:36 babolo Exp $
 */

#define PGO_COUT    0
#define PGO_POUT    0
#define PGO_CCTL    1
#define PGO_PCTL    1
#define PGO_CIN     2
#define PGO_PIN     3
#define PGO_CCON    3
#define PGO_PCON    2
#define PGO_CSTY    4
#define PGO_PSTY    (pgoblin_a[cmd].flags & PGOBLIN_STYLEN)

#define IO_RG0      (options->io[0])
#define IO_OUT      (options->io[a[PGO_POUT]])
#define IO_CTL      (options->io[a[PGO_PCTL]])
#define IO_IN       (options->io[a[PGO_PIN]])
#define R_CONN      (options->conn[a[PGO_PCON]])
#define CH_OUT      (pgoblin_a[cmd].ch[PGO_POUT])
#define CH_CTL      (pgoblin_a[cmd].ch[PGO_PCTL])
#define CH_IN       (pgoblin_a[cmd].ch[PGO_PIN])
#define CH_CON      (pgoblin_a[cmd].ch[PGO_PCON])

#define PGOBLIN_BUFSIZE   8192
#define PGOBLIN_BUFMULT   2
#define PGOBLIN_RAWIOBUFL 1

#define PQEXEC(RESULT, QUERY, CONDITION, CCODE) {                                                    \
    ifBLIN_QV3(options->flags) fprintf(stderr, "PQexec: %s\n", (char*)(QUERY));                             \
    (RESULT) = PQexec(R_CONN.conn, (QUERY));                                                         \
    if  (!(RESULT)) {                                                                                \
        ifBLIN_QV1(options->flags) warnx("result is absent - fatal error.\n"); return(CCODE);        \
    }                                                                                                \
    ifBLIN_QV3(options->flags) fprintf(stderr, "PQresultStatus %d\n", PQresultStatus(RESULT));       \
    if  (PQresultStatus(RESULT) != (CONDITION)) {                                                    \
        if  (PQresultStatus(RESULT) == PGRES_FATAL_ERROR) {                                          \
            ifBLIN_QV1(options->flags) warnx("PQexec failed: %s", PQresultErrorMessage(RESULT));     \
            return(CCODE);                                                                           \
        } else if ((CONDITION) == PGRES_COMMAND_OK && PQresultStatus(RESULT) == PGRES_TUPLES_OK) {   \
            ifBLIN_QV2(options->flags) warnx("PQexec wait for COMMAND_OK but received TUPLES_OK");   \
        } else ifBLIN_QV1(options->flags) {                                                          \
            warnx("PQexec wait for %d but received %d", (CONDITION), PQresultStatus(RESULT));        \
            return(CCODE);                                                                           \
}   }   }

#define PROCDIR "/proc/"
#define CMDLINE "/cmdline"
#define PIDLENG 8
#define TOTALEN (strlen(PROCDIR) + PIDLENG + strlen(CMDLINE) + 1)

extern const pgoblin_c pgoblin_a[PGOBLIN_max];

int      pgoblin_shurecon __P((pgoblin_con *options, int a[]));
int        pgoblin_listen __P((pgoblin_con *options, int a[]));
int         pgoblin_begin __P((pgoblin_con *options, int a[]));
int           pgoblin_end __P((pgoblin_con *options, int a[]));
int       pgoblin_perform __P((pgoblin_con *options, int a[]));
int          pgoblin_echo __P((pgoblin_con *options, int a[]));
int           pgoblin_cat __P((pgoblin_con *options, int a[]));
int          pgoblin_exec __P((pgoblin_con *options, int a[]));
int          pgoblin_fork __P((pgoblin_con *options, int a[]));
int        pgoblin_copyin __P((pgoblin_con *options, int a[]));
int       pgoblin_copyout __P((pgoblin_con *options, int a[]));
int        pgoblin_binsel __P((pgoblin_con *options, int a[]));
int        pgoblin_strsel __P((pgoblin_con *options, int a[]));
int        pgoblin_binpre __P((pgoblin_con *options, int a[]));
int        pgoblin_select __P((pgoblin_con *options, int a[]));
int       pgoblin_display __P((pgoblin_con *options, int a[]));
int        pgoblin_getarg __P((pgoblin_con *options, int a[]));
int        pgoblin_getenv __P((pgoblin_con *options, int a[]));
int        pgoblin_getget __P((pgoblin_con *options, int a[]));
int       pgoblin_getpost __P((pgoblin_con *options, int a[]));
int       pgoblin_getproc __P((pgoblin_con *options, int a[]));
